* SYMTAB5.ASM

 SETDP 0

TXTTAB EQU $19
VARTAB EQU $1B
ARYEND EQU $1F
MEMSIZ EQU $27
LINBUF EQU $2DC
CHARAD EQU $0A6
FIX EQU $0ACE9
DIRECTLOOP EQU $0AC73
INITIALIZE EQU $0AD21
CRUNCH EQU $0B824

EQTOKEN EQU 179
REMTOKEN EQU 130
REMQUOTE EQU 131

 ORG $7400
 
HIGH FCB 1
LOMEM EQU *
 FDB $2000 ;LINE
 FDB $2100 ;VARIABLES
 FDB $2400 ;TEXT
 FDB $7400 ;LABELS

HIMEM EQU *
 FDB $7F00 ;LINE
 FDB $8000 ;VARIABLES
 FDB $8300 ;TEXT
 FDB $0FE00 ;LABELS

MEMS EQU *
LINE FDB 0
VARIABLES FDB 0
TEXT FDB 0
LABELS FDB 0

TABLE FCC /REM,/
REM FCC /GOSUB,/
GOSUB FCC /ON,/
ON FCC /GOTO,RUN,THEN,ELSE,/
 FCB 0
LLMESG FCC /LINE TOO LONG/
 FCB 0
OMMESG FCC /OUT OF MEMORY/
 FCB 0
INDEX FDB 0
LINUM FDB 0
DIVISORS FDB 10000
 FDB 1000
 FDB 100
TEN FDB 10
CHAR FCB 0
SHOW FCB 0
POINT FDB TEXT
SOURCE FDB TEXT
LENGTH FCB 0
WHERE FDB 0
LABELEND FDB LABELS
OPWHERE FDB 0
OPONCE FCB 0
ONSKIP FCB 0
ONUM FCB 0
ONFLAG FCB 0
ONPOINT FDB TEXT
BASPOINT FDB 0
PREFIX FCC /AA/
DATAEND EQU *
 
 ORG $7500
MEMORY FCB 0
LONGLINE FCB 0
COCO3 FCB 0
IMMEDIATE FCB 1 ;ALWAYS ONE
 BRA USR0 
 BRA USR1
 BRA USR2
 LBRA USR3

USR0 LBSR MACHINE
 LBSR MEMS0
 LDX #0
 STX LINUM
 STX INDEX
 LDX TEXT
 CLR ,X
 STX SOURCE
 STX POINT
 LDX LABELS
 CLR -1,X
 CLR -2,X
 CLR -3,X
 STX LABELEND
 CLR MEMORY
 LBSR BASIC
 RTS

USR2 LDU LINE
 STU 2,X
 CLR LONGLINE
 LDD INDEX
 LBSR NUMOUT
 TFR U,D
 SUBD LINE
 STB ,X
 LDX TXTTAB
 STX BASPOINT
 LDX SOURCE
 STX POINT
 LDX #0
 STX LINUM
 CLR ONSKIP
 CLR ONUM
 CLR ONFLAG
 LDA #'A
 STA PREFIX
 STA PREFIX+1
 CLR [VARIABLES]
 RTS

USR1 LBSR MACHINE
 LDB ,X
 LBEQ EXIT1
 TST MEMORY
 LBNE EXIT1
 CLRA
 STB LENGTH
 STD ,--S
 LDD POINT
 ADDD ,S++
 CMPD LABELEND
 BLO OK1
 CLR ,X
 INC MEMORY
 BRA EXIT1
OK1 LDU 2,X
 STU WHERE
 LDD LINUM
 ADDD #10
 STD LINUM
 LDD ,U
 CMPA #'Z
 BNE NOTLABEL1
 CMPB #'=
 BNE NOTLABEL1
 LDD INDEX
 ADDD #1
 STD INDEX
 LDB LENGTH
 CMPB #2
 BLS NOTLABEL1
 LDX LABELEND
 LDU WHERE
 DECB
 LEAU 2,U
 BRA LABIN1
LABEL1 LDA ,U+
 CMPA #'0
 BLO LABDONE1
 CMPA #'9
 BLS LABGOOD1
 CMPA #'A
 BLO LABDONE1
 CMPA #'Z
 BHI LABDONE1
LABGOOD1 STA ,-X
LABIN1 DECB
 BNE LABEL1
LABDONE1 LDA #$D
 STA ,-X
 LDD LINUM
 STD ,--X
 CLR -1,X
 STX LABELEND
 CLR -2,X
 CLR -3,X
NOTLABEL1 LDX POINT
 LDU WHERE
 LDB LENGTH
 BEQ DONE1
LOOP1 LDA ,U+
 STA ,X+
 DECB
 BNE LOOP1
DONE1 LDA #$D
 STA ,X+
 CLR ,X
 STX POINT
EXIT1 LBSR BASIC
 RTS

MEMS0 LDX #HIMEM
 TST HIGH
 BNE HIGH0
 LDX #LOMEM
HIGH0 LDB #$8
 LDU #MEMS
LOOP0 LDA ,X+
 STA ,U+
 DECB
 BNE LOOP0
 RTS

BASIC TST COCO3
 BNE BASIC3
 CLR $FFDE
 RTS
BASIC3 PSHS A
 LDA #$3C
MACHINE3 STA $0FFA4
 INCA
 STA $0FFA5
 INCA
 STA $0FFA6
 INCA
 STA $0FFA7
 PULS A,PC 

MACHINE ORCC #$50
 TST COCO3
 BEQ MACHINE2
 PSHS A
 LDA #$30
 BRA MACHINE3
MACHINE2 CLR $FFDF
 RTS

FIND PSHS U
 LDU LABELS
 STX WHERE
 CLR LENGTH
 DEC LENGTH
 LDY #0
FINDLEN INC LENGTH
 LDA ,X+
 CMPA #'0
 BLO OUTER
 CMPA #9
 BLS FINDLEN
 CMPA #'A
 BLO OUTER
 CMPA #'Z
 BLS FINDLEN
OUTER LEAY 1,Y
 LDX WHERE
 LDB LENGTH
INNER LDA ,-U
 BEQ NEW
 CMPA ,X+
 BNE SKIPIN
 DECB
 BNE INNER
 LDA ,-U
 CMPA #$D
 BEQ FOUND
SKIP LDA ,-U
 BEQ NEW
SKIPIN CMPA #$D
 BNE SKIP
 LEAU -2,U
 BRA OUTER
NEW LDY #0
FOUND STY INDEX
 LDD ,--U
 PULS U,PC

VARIABLE CMPA #'Z
 BNE NOTZEQ
 LDB ,X
 CMPB #EQTOKEN
 BNE NOTZEQ
 STA ,U+
 LDA ,X+
 LBSR NUMBER
 RTS
NOTZEQ PSHS U
 LDU VARIABLES
 LDA ,-X
 STX WHERE
 LDA ,X+
 CLRB
 LDY #0
VARLEN INCB
 LDA ,X+
 CMPA #'0
 BLO TESTONE
 CMPA #9
 BLS VARLEN
 CMPA #'A
 BLO TESTONE
 CMPA #'Z
 BLS VARLEN
TESTONE STB LENGTH
 CMPB #1
 BEQ ONE
OUTERV LEAY 1,Y
 LDX WHERE
 LDB LENGTH
INNERV LDA ,U+
 BEQ NEWBACK
 CMPA ,X+
 BNE SKIPINV
 DECB
 BNE INNERV
 LDA ,U+
 CMPA #$D
 BEQ FOUNDV
SKIPVAR LDA ,U+
 BEQ NEWV
SKIPINV CMPA #$D
 BNE SKIPVAR
 LEAU 2,U
 BRA OUTERV
NEWBACK LEAU -1,U
NEWV LDA ,X+
 STA ,U+
 DECB
 BNE NEWV
 LDA #13
 STA ,U+
 LDD PREFIX
 STD ,U
 CMPB #'Z
 BLO NEWPRE
 INCA
 LDB #'A-1
NEWPRE INCB
 STD PREFIX
 CLR 2,U
FOUNDV STY INDEX
 LDD ,U
 PULS U
 STD ,U++
 BRA MORE
ONE PULS U
MORE LDX WHERE
 LDB LENGTH
VARSTORE LDA ,X+
 STA ,U+
 DECB
 BNE VARSTORE
 LDA ,X+
 RTS

NUMBER STA ,U+
 LDA ,X+
 CMPA #'.
 BEQ NUMBER
 CMPA #'0
 BLO NUMRET
 CMPA #'9
 BLS NUMBER
 CMPA #'A
 BLO NUMRET
 CMPA #'Z
 BLS NUMBER
NUMRET RTS

NUMOUT PSHS X,B,A
 CLR SHOW
 LDX #DIVISORS-2
NUMOCHAR CLR CHAR
 LEAX 2,X
 BRA NUMOIN
NUMOLOOP SUBD ,X
 INC CHAR
NUMOIN CMPD ,X
 BHS NUMOLOOP
 TST CHAR
 BEQ NUMOMAY
 INC SHOW
NUMOMAY TST SHOW
 BEQ NUMONOT
 PSHS A
 LDA CHAR
 ADDA #'0
 STA ,U+
 PULS A
NUMONOT CMPX #TEN
 BNE NUMOCHAR
 ADDB #'0
 STB ,U+
 PULS A,B,X,PC

COPY PSHS X
 LDX WHERE
COPYLOOP LDA ,X+
 STA ,U+
 CMPX ,S
 BLO COPYLOOP
 PULS X,PC
 
SPPRINT STA ,U+
SPACES LDA ,X+
 CMPA #$20
 BEQ SPPRINT
 RTS
 
USR3 LDU LINE
 STU 2,X
 PSHS X
LINE3 LBSR MACHINE
 TST LONGLINE
 BEQ NOTLONG3
 CLRB
 TST IMMEDIATE
 LBEQ DONE3
 LBRA IMLONG3
NOTLONG3 CLR ONSKIP
 LDU LINE
 TST ONFLAG
 BEQ NOTDOON3
 CLR ONFLAG
 LDX ONPOINT
 LDD LINUM
 ADDD #5
 INC ONUM
 TST IMMEDIATE
 BNE SKIPON3
 CLR ONUM
 LBSR NUMOUT
 LDA #$20
 STA ,U+
SKIPON3 LDA #39
ONCOPY3 STA ,U+
 LDA ,X+
 CMPA #13
 BNE ONCOPY3
 LBRA EXIT3
NOTDOON3 LDX POINT
 STX ONPOINT
 LDB ,X
 LBEQ DONE3
 LDD LINUM
 ADDD #10
 STD LINUM
 TST IMMEDIATE
 LBNE IN3
 LBSR NUMOUT
 LDA #$20 
 STA ,U+
 LBRA IN3
CHAR3 CMPA #$27
 BNE NOTQ3
QUOTE3 STA ,U+
REM3 LDA ,X+
 CMPA #$D
 BNE QUOTE3
 LBRA EXIT3
NOTQ3 CMPA #'"
 BNE NOTDQ3
DOUBLEQ3 STA ,U+
 LDA ,X+
 CMPA #$D
 LBEQ EXIT3
 CMPA #'"
 BNE DOUBLEQ3
 LBRA PRINT3
NOTDQ3 CMPA #'A
 LBLO PRINT3
 CMPA #'Z
 LBHI PRINT3
 LEAX -1,X
 CLR OPONCE
 LDB #13
OPAGAIN3 LDY #TABLE
 STX WHERE
 CMPB ,X
 LBEQ IN3
OPLOOP3 LDX WHERE
OPWORD3 LDA ,Y+
 CMPA ,X+
 BEQ OPWORD3
 CMPA #',
 BEQ OPFOUND3
 LDA #',
OPSKIP3 CMPA ,Y+
 BNE OPSKIP3
 TST ,Y
 BNE OPLOOP3
 TST OPONCE
 BNE OPONCE3
 LDX WHERE
 LDA ,X+
NAME3 STA ,U+
 LDA ,X+
 CMPA #13
 LBEQ EXIT3
 CMPA #'0
 LBLO PRINT3
 CMPA #9
 BLS NAME3
 CMPA #'A
 LBLO PRINT3
 CMPA #'Z
 BLS NAME3
 LBRA PRINT3
OPFOUND3 LEAX -1,X
 LBSR COPY
 CMPY #REM
 LBEQ REM3
 LBSR SPACES
 CMPA #$D
 BEQ EXIT3
 LEAX -1,X
 INC OPONCE
 STY OPWHERE
 CMPY #ON
 BNE OPAGAIN3
 INC ONFLAG
 INC ONSKIP
 BRA IN3
OPONCE3 LDX WHERE
ONLOOP LBSR FIND
 BEQ ZERO3
 LBSR NUMOUT
ZERO3 LDX WHERE
 LDB LENGTH
 LEAX B,X
 TST ONSKIP
 BEQ NOTONSKIP3
 LBSR SPACES
 LEAX -1,X
 CMPA #':
 BNE NOTONDONE3
 CLR ONSKIP
 BRA IN3
NOTONDONE3 CMPA #',
 BNE IN3
 STA ,U+
 LEAX 1,X
 LBSR SPACES
 LEAX -1,X
 BRA ONLOOP
NOTONSKIP3 LDA ,X
 CMPA #13
 BEQ  NOTGOSUB3
 LDY OPWHERE
 CMPY #GOSUB
 BNE NOTGOSUB3
 LDA #':
 STA ,U+
 LDA #'Z
 STA ,U+
 LDA #'=
 STA ,U+
NOTGOSUB3 LBSR COPY
 BRA IN3
PRINT3 STA ,U+
IN3 LDA ,X+
 CMPA #$D
 LBNE CHAR3
EXIT3 STX POINT
 CLR ,U
 TFR U,D
 SUBD LINE
 TSTA
 BEQ DONE3
 LDB #255
 INC LONGLINE
 LBSR BASIC
 LDX #LLMESG
OMIN3 LDA ,X+
MESG3 JSR [$A002]
 LDA ,X+
 BNE MESG3
 TST IMMEDIATE
 BEQ DONE3
 LDU BASPOINT
 CLR ,U+
 CLR ,U+
 LBRA IMDONE3
DONE3 LBSR BASIC
 TST IMMEDIATE
 BNE IMMEDIATE3
 PULS X
 STB ,X
 RTS
IMMEDIATE3 LDX LINE
 STX CHARAD
IMLONG3 LDU BASPOINT
 CLR ,U+
 CLR ,U+
 TSTB
 LBEQ IMDONE3
 LDD LINUM
 TST ONUM
 BEQ NOTONUM3
 ADDD #5
 CLR ONUM
 CLR ONSKIP
 CLR ONFLAG
NOTONUM3 STD ,U++
 JSR CRUNCH
 LDX BASPOINT
 LEAX D,X
 CMPX #TABLE-6
 BLS NOTOM3
 INC MEMORY
 LDX #OMMESG
 BRA OMIN3
NOTOM3 LDU BASPOINT
 LEAU 4,U
 LDX #LINBUF
LDA3 LDA ,X+
 CMPA #'0
 BLO NOTHING3
 CMPA #'9
 BHI VARIABLE3
 LBSR NUMBER
 BRA NOTHING3
VARIABLE3 CMPA #'A
 BLO NOTHING3
 CMPA #'Z
 BHI NOTHING3
 LBSR VARIABLE
NOTHING3 STA ,U+
 CMPA #':
 BNE MAYBEREM3
 LDB ,X
 CMPB #REMQUOTE
 BNE MAYBEREM3
 BSR QUOTE
 BEQ COPYEXIT3
MAYBEREM3 CMPA #REMTOKEN
 BNE NOTREM3
 BSR REMLOOP
 BRA COPYEXIT3
NOTREM3 TSTA
 BEQ COPYEXIT3
 CMPA #'"
 BNE LDA3
 BSR DBLQUOTE
 TSTA
 BNE LDA3
COPYEXIT3 STU [BASPOINT]
 STU BASPOINT 
 JMP LINE3
IMDONE3 STU VARTAB
 JSR INITIALIZE
 JMP DIRECTLOOP

DBLQUOTE LDA ,X+
 STA ,U+
 BEQ QUOTEXIT
 CMPA #'"
 BNE DBLQUOTE
 RTS

QUOTE LDA ,X+
 STA ,U+
 CMPA #REMQUOTE
 BNE QUOTEXIT
REMLOOP LDA ,X+
 STA ,U+
 BNE REMLOOP
QUOTEXIT RTS

LAST EQU *

 END
