* SYMTAB6.ASM

 SETDP 0
 
DIFF EQU $8000

HIGHVAL EQU 1

TXTTAB EQU $19
VARTAB EQU $1B
MEMSIZ EQU $27
FPA0 EQU $50
GETNCH EQU $9F
RVEC17 EQU $191 ; ERROR
RVEC23 EQU $1A3 ; CRUNCH
RVEC24 EQU $1A6 ; UNCRUNCH
LINBUF EQU $2DC
CHARAD EQU $0A6
FIX EQU $0ACE9
DIRECTLOOP EQU $0AC73
INITIALIZE EQU $0AD21
GOTOSUB EQU $0AE88
EVALEXPR EQU $0B70B
CRUNCH EQU $0B824

GOTOKEN EQU 129
REMTOKEN EQU 130
QUOTOKEN EQU 131
ONTOKEN EQU 136
TOTOKEN EQU 165
SUBTOKEN EQU 166
EQTOKEN EQU 179

TEXT EQU $2000

 ORG $7F00

START BRA PREPARE0
 BRA PREPARE1
 BRA PREPARE2
PREPARE0 BSR MACHINE
 LBSR USR0+DIFF
 BSR BASIC
 RTS
PREPARE1 LDU CHARAD
 PSHS U
 LDX 2,X
 STX CHARAD
 JSR CRUNCH
 BSR MACHINE
 LDU POINT+DIFF
 LBSR USR1+DIFF
 STU POINT+DIFF
 PULS U
 STU CHARAD
 BSR BASIC
 RTS
PREPARE2 BSR MACHINE
 LBSR USR2+DIFF
 BSR BASIC
 JSR INITIALIZE
JUMP JMP DIRECTLOOP
PREPARE17 CMPB #1*2 ; SN
 BEQ HOOKIN17
 CMPB #2*7 ; UL
 BNE RETURN17
HOOKIN17 BSR MACHINE
 JSR HOOK17+DIFF
 BSR BASIC
 CMPB #1
 BEQ UL2GO17
 CMPB #3
 BEQ ON2SN17
 CMPB #5 ; ON FALL THRE
 BNE RETURN17
 JSR GETNCH
 LEAS 2,S ; ON FALL THRU 
UL2GO17 LEAS 2,S
 RTS
PREPARE23 RTS

EVAL17 BSR BASIC
 JSR EVALEXPR
 BSR MACHINE
 RTS
 
ON2SN17 LDB #2
RETURN17 FCB 0
 FDB 0
 
RETURN23 FCB 0
 FDB 0
 
TOSUB17 BSR BASIC
 LEAS 6,S
 JMP GOTOSUB

BASIC
 PSHS A
 LDA #$3C
 BRA BASICIN
MACHINE ORCC #$50
 PSHS A
 LDA #$2C
BASICIN STA $0FFA4
 INCA
 STA $0FFA5
 INCA
 STA $0FFA6
 INCA
 STA $0FFA7
LAST PULS A,PC

 ORG $0FFA3
 FCB $2F

 ORG $6000

HIGHMEM FCB HIGHVAL ;PUT SYMBOL TABLE IN HIGH LOGICAL MEMORY
LOVALUES EQU *
 FDB $5000 ;VARIABLES
 FDB $6C00 ;VARIEND
 FDB $6C00 ;LINE
 FDB $5000 ;TEXTEND
HIVALUES EQU *
 FDB $8300 ;VARIABLES
 FDB $0E000 ;VARIEND
 FDB $7F00 ;LINE
 FDB $7000 ;TEXTEND
VALUES EQU *
VARIABLES FDB $5000
VARIEND FDB $6C00
LINE FDB $6C00
TEXTEND FDB $5000
PREFIX FCC /AA/
LENGTH FCB 0
WHERE FDB 0
LINUM FDB 0
INDEX FDB 0
POINT FDB 0
MEMORY FCB 0
LONGLINE FCB 0
 
USR0 LDA RVEC17
 LDX RVEC17+1
 STA RETURN17
 STX RETURN17+1
 LDA JUMP
 LDX #PREPARE17
 STA RVEC17
 STX RVEC17+1
 LDA RVEC23
 LDX RVEC23+1
 STA RETURN23
 STX RETURN23+1
 LDA JUMP
 LDX #PREPARE23
* STA RVEC23
* STX RVEC23+1
 LDB #8
 LDU #VALUES+DIFF
 LDX #LOVALUES+DIFF
 TST HIGHMEM+DIFF
 BEQ LOWMEM0
 LDX #HIVALUES+DIFF
LOWMEM0 LDA ,X+
 STA ,U+
 DECB
 BNE LOWMEM0
 LDX #0
 STX LINUM+DIFF
 STX INDEX+DIFF
 CLR MEMORY+DIFF
 CLR LONGLINE+DIFF
 LDA #'A
 STA PREFIX+DIFF
 STA PREFIX+1+DIFF
 CLR [VARIABLES+DIFF]
 LDX #TEXT
 CLR ,X+
 CLR ,X+
 STX POINT+DIFF
 RTS

ADRES1 FDB 0
ADRES2 FDB 0
USR1 LDX #LINBUF
 STX ADRES2+DIFF
SPACE1 LDA ,X+
 CMPA #$20
 BEQ SPACE1
 STX ADRES1+DIFF
 CMPA #'A
 BLO RESET1
 CMPA #'Z
 BHI RESET1
LONG1 LDA ,X+
 CMPA #'0
 BLO MAYBE1
 CMPA #'9
 BLS LONG1
 CMPA #'A
 BLO MAYBE1
 CMPA #'Z
 BLS LONG1
MAYBE1 TSTA
 BEQ RESET1
 CMPA #$20
 BNE COLON1
 LDA ,X+
 BRA MAYBE1
COLON1  CMPA #':
 BNE RESET1
 STX ADRES2+DIFF
 LDA #'Z
 STA ,U+
 STA ,U+
 LDA #EQTOKEN
 STA ,U+
 LDX ADRES1+DIFF
 LDA -1,X
 LBSR VARIABLE
 STA ,U+
 LDA #':
 STA ,U+
RESET1 LDX ADRES2+DIFF
LOOP1 LDA ,X+
 CMPA #ONTOKEN
 BNE NOTON1
 LDB #'!
 STB ,U+
 STA ,U+
 LDA ,X+
NOTON1 CMPA #'"
 BNE NOTDBLQ1
DBLQ1 STA ,U+
 LDA ,X+
 BEQ EXIT1
 CMPA #'"
 BNE DBLQ1
 STA ,U+
 LDA ,X+
NOTDBLQ1 CMPA #REMTOKEN
 BEQ QUOTE1
 CMPA #':
 BNE NOTQUOTE1
 LDB ,X
 CMPB #QUOTOKEN
 BNE NOTQUOTE1
QUOTE1 STA ,U+
 LDA ,X+
 BNE QUOTE1 
 BRA EXIT1
NOTQUOTE1 CMPA #'A
 BLO EXIT1
 CMPA #'Z
 BHI EXIT1
 LBSR VARIABLE
EXIT1 STA ,U+
 BNE LOOP1
 RTS

USR2 LDX POINT+DIFF
 LEAX -1,X
 LDU TEXTEND+DIFF
 CLR ,-U
 CLR ,-U
 BRA COPYLINE2
COPYCHAR2 STA ,-U
 LDA ,-X
 BNE COPYCHAR2
 STA ,-U
COPYLINE2 LDA ,-X
 BNE COPYCHAR2
 LEAU 1,U
 LDX TXTTAB
 STX VARTAB
 LDY #0
 BRA MOVEIN2
MOVELINE2 STX VARTAB 
 CLR ,X+
 CLR ,X+
 LEAY 1,Y
 STY ,X++
MOVECHAR2 STA ,X+
 LDA ,U+
 BNE MOVECHAR2
 STA ,X+
 STX [VARTAB]
MOVEIN2 LDA ,U+
 BNE MOVELINE2
 CLR ,X+
 CLR ,X+
 STX VARTAB
RTS3 RTS

FLAG3 FCB 0
HOOK17 CMPB #2*7 ; UL ENTRY
 BEQ UL3
 CMPB #2*1 ; SN ENTRY
 BNE RTS3
 LDX CHARAD
 LDA ,X
 CMPA #'!
 BNE RTS3
 LDA 1,X
 CMPA #ONTOKEN
 BNE RTS3
 LEAX 2,X
 LDA ,X
 STX CHARAD
 JSR EVAL17
 LDX CHARAD
 LDD ,X++
 CMPA #GOTOKEN
 LBNE ON2SN3
 CMPB #TOTOKEN
 BEQ LOOP3
 CMPB #SUBTOKEN
 BEQ LOOP3
ON2SN3 LDB #3 ; SN FROM SN ENTRY
 RTS
LOOP3 DEC FPA0+3
 BNE ALPHVAL3
TOSUB3 LEAX -1,X
 STX CHARAD
 JMP TOSUB17
ALPHVAL3 LDA ,X+
 CMPA #$20
 BEQ ALPHVAL3
 CMPA #'A
 BLO SING3
 CMPA #'Z
 BHI SING3
 LDA ,X
 CMPA #'0
 BLO SING3
 CMPA #'9
 BLS DOUB3
 CMPA #'A
 BLO SING3
 CMPA #'Z
 BHI SING3
DOUB3 LEAX 1,X
SING3 LDA ,X+
 CMPA #$20
 BEQ SING3
 CMPA #',
 BEQ LOOP3
 LEAX -2,X
 STX CHARAD
 LDB #5 ; FALL THRU FROM SN ENTRY
 RTS 
UL3 LDA #'Z
 LDB #'Z
 TFR D,U
 CLR FLAG3+DIFF
 INC FLAG3+DIFF
 LDX CHARAD
SPACE3 LDA ,X+
 CMPA #$20
 BEQ SPACE3
 LDB ,X
 CMPA #'A
 BLO UL2UL
 CMPA #'Z
 BHI UL2UL
 CMPB #'0
 BLO SINGLE3
 CMPB #'9
 BLS DOUBLE3
 CMPB #'A
 BLO SINGLE3
 CMPB #'Z
 BLS DOUBLE3
SINGLE3 LDB #':
DOUBLE3 TST ,X+
 BNE DOUBLE3
 BRA DOWNIN3
DOWN3 LDX ,X
 BEQ BOTTOM3
DOWNIN3 CMPD 7,X
 BNE DOWN3
 CMPU 4,X
 BNE DOWN3
 LEAX -1,X
 STX CHARAD
 LDB #1 ; GOOD RETURN FROM UL
 RTS
BOTTOM3 LDX TXTTAB
 DEC FLAG3+DIFF
 BEQ DOWNIN3
UL2UL LDB #7*2 ; UL FROM UL ENTRY
 RTS
 
HOOK23 RTS

ALPHVAL LDA ,X+
 CMPA #$20
 BEQ ALPHVAL
 CMPA #'A
 BLO AVEMPTY
 CMPA #'Z
 BHI AVEMPTY
 LDB ,X+
 CMPB #'0
 BLO AVSINGLE
 CMPB #'9
 BLS AVDOUBLE
 CMPB #'A
 BLO AVSINGLE
 CMPB #'Z
 BLS AVDOUBLE
AVSINGLE LDB #':
 LEAX -1,X
 RTS
AVEMPTY CLRB
AVDOUBLE RTS

VARIABLE STX WHERE+DIFF
 CLRB
VARLEN LDA ,X+
 INCB
 CMPA #'0
 BLO TESTONE
 CMPA #9
 BLS VARLEN
 CMPA #'A
 BLO TESTONE
 CMPA #'Z
 BLS VARLEN
TESTONE CMPB #1
 BNE MORE
 LDA -2,X
 LEAX -1,X
 RTS
MORE PSHS U
 LDX WHERE+DIFF
 LEAX -1,X
 STX WHERE+DIFF
 STB LENGTH+DIFF
 LDU VARIABLES+DIFF
 BRA LOOPIN
LOOP CMPA ,X+
 BNE SKIPIN
 LDA ,U+
 CMPA #$D
 BEQ FOUND
 DECB
 BNE LOOP
SKIP LDA ,U+
SKIPIN CMPA #$D
 BNE SKIP
 LEAU 2,U
 LDB LENGTH+DIFF
 LDX WHERE+DIFF
LOOPIN LDA ,U+
 BNE LOOP
 LEAU -1,U
NEW LDA ,X+
 STA ,U+
 DECB
 BNE NEW
 LDA #13
 STA ,U+
 LDD PREFIX+DIFF
 STD ,U
 CMPB #'Z
 BLO NEWPRE
 INCA
 LDB #'A-1
NEWPRE INCB
 STD PREFIX+DIFF
 CLR 2,U
FOUND LDX WHERE+DIFF
 LDB LENGTH+DIFF
 LEAX B,X
 LDD ,U
 PULS U
 STA ,U+
 TFR B,A
 RTS
 
 ORG $0FFA3
 FCB $3B
 
 END START
 